@rem = '--*-Perl-*--
@echo off
if "%OS%" == "Windows_NT" goto WinNT
perl -x -S "%0" %1 %2 %3 %4 %5 %6 %7 %8 %9
pause
goto endofperl
:WinNT
perl -x -S %0 %*
pause
if NOT "%COMSPEC%" == "%SystemRoot%\system32\cmd.exe" goto endofperl
if %errorlevel% == 9009 echo You do not have Perl in your PATH.
if errorlevel 1 goto script_failed_so_exit_with_non_zero_val 2>nul
goto endofperl
@rem ';
#!/usr/bin/perl -w
#line 17

use strict;
my $outfile = my $file = $ARGV[0] or die "``bt@CccĂB";
$outfile =~ s/\.\w+$//;
open my $in,"<:raw",$file or die $!;
my $last_channel = -1;
my( $aac , $head , $tmp);
my $count=0;
while(read($in,$head,7)){
	my($sync,$n,$nn)=unpack("CnN",$head);
	if($sync != 255 || ($n & 0xF600) != 0xF000){
		print "not sync($sync,$n,$nn)\n";
		exit;
	}
	my $channel_configuration = (($n & 0x1) << 2) | ($nn>>30);
	my $aac_frame_length = $nn >> 13 & 0x1FFF;
	if($last_channel != $channel_configuration){
		close $aac if $aac;
		$count++;
		my $filename = sprintf("%s %02d %02dch.aac",$outfile,$count,$channel_configuration);
		open $aac,">:raw",$filename or die $!;
		print "$filename\n";
		$last_channel = $channel_configuration;
	}
	$n &= 0xF7FF;
	$nn |= 0x80000000 if $channel_configuration == 0;
	read($in,$tmp,$aac_frame_length-7);
	print $aac pack("CnN",$sync,$n,$nn);
	print $aac $tmp;
}
close $aac if $aac;
